org.apache.commons.compress.archivers.zip

## Interface ZipEncoding

-     public interface ZipEncoding

  An interface for encoders that do a pretty encoding of ZIP file names.

  There are mostly two implementations, one that uses java.nio `Charset` and one implementation, which copes with simple 8 bit charsets, because java-1.4 did not support Cp437 in java.nio.

  The main reason for defining an own encoding layer comes from the problems with `String.getBytes`, which encodes unknown characters as ASCII quotation marks ('?'). Quotation marks are per definition an invalid file name on some operating systems like Windows, which leads to ignored ZIP entries.

  All implementations should implement this interface in a reentrant way.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `boolean` | `canEncode(String name)` Check, whether the given string may be losslessly encoded using this encoding.
    `String` | `decode(byte[] data)`
    `ByteBuffer` | `encode(String name)` Encode a file name or a comment to a byte array suitable for storing it to a serialized ZIP entry.

- - ### Method Detail

    - #### canEncode

          boolean canEncode(String name)

      Check, whether the given string may be losslessly encoded using this encoding.
      Parameters:
        `name` - A file name or ZIP comment.
      Returns:
        Whether the given name may be encoded with out any losses.

    - #### decode

          String decode(byte[] data)
                 throws IOException

      Parameters:
        `data` - The byte values to decode.
      Returns:
        The decoded string.
      Throws:
        `IOException` - on error

    - #### encode

          ByteBuffer encode(String name)
                     throws IOException

      Encode a file name or a comment to a byte array suitable for storing it to a serialized ZIP entry.

      Examples for CP 437 (in pseudo-notation, right hand side is C-style notation):

            encode("?_for_Dollar.txt") = "%U20AC_for_Dollar.txt"
            encode("Ölfässer.txt") = "\231lf\204sser.txt"

      Parameters:
        `name` - A file name or ZIP comment.
      Returns:
        A byte buffer with a backing array containing the encoded name. Unmappable characters or malformed character sequences are mapped to a sequence of utf-16 words encoded in the format `%Uxxxx`. It is assumed, that the byte buffer is positioned at the beginning of the encoded result, the byte buffer has a backing array and the limit of the byte buffer points to the end of the encoded result.
      Throws:
        `IOException` - on error

Copyright © 2002–2022 The Apache Software Foundation. All rights reserved.